## widelands 1.3

=== src/CMakeLists.txt ===
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/build_info.cc.cmake ${CMAKE_CURRENT_BINARY_DIR}/build_info.cc)
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/../cmake/datadirversion.cmake ${CMAKE_CURRENT_SOURCE_DIR}/../data/datadirversion)

# Catchall target to codecheck all files.
add_custom_target(codecheck)
add_custom_target(run_build_deps
  COMMAND
    ${Python3_EXECUTABLE}
    ${CMAKE_SOURCE_DIR}/utils/build_deps.py
  COMMENT "Checking CMakeLists.txt files."
)
add_dependencies(codecheck run_build_deps)

# A target that depends on all unit tests as 'make test' will not rebuild
# tests:
# https://stackoverflow.com/questions/733475/cmake-ctest-make-test-doesnt-build-tests
add_custom_target(wl_tests)

#include the cmake version dependend macro _include_directories
if (CMAKE_VERSION VERSION_LESS 2.8.11)
  include (${CMAKE_SOURCE_DIR}/cmake/IncludeDirectoriesOld.cmake)
else (CMAKE_VERSION VERSION_LESS 2.8.11)
  include (${CMAKE_SOURCE_DIR}/cmake/IncludeDirectories.cmake)
endif (CMAKE_VERSION VERSION_LESS 2.8.11)

wl_library(build_info
  SRCS
    build_info.cc
    build_info.h
)

if (WIN32)
	configure_file (${CMAKE_CURRENT_SOURCE_DIR}/../utils/windows/widelands.rc.cmake ${CMAKE_CURRENT_BINARY_DIR}/widelands.rc)
	message (STATUS "Configured windows resource file")
	set(WIN32_ICON_O ${CMAKE_CURRENT_BINARY_DIR}/wl_icon.o)
	if(MSVC)
		ADD_CUSTOM_COMMAND(OUTPUT ${WIN32_ICON_O}
			COMMAND rc
				/fo ${WIN32_ICON_O}
				${CMAKE_CURRENT_BINARY_DIR}/widelands.rc
		)
	else()
		ADD_CUSTOM_COMMAND(OUTPUT ${WIN32_ICON_O}
			COMMAND ${MINGW_PREFIX}windres
				-o${WIN32_ICON_O}
				-i${CMAKE_CURRENT_BINARY_DIR}/widelands.rc
		)
	endif()

  wl_binary(widelands
    WIN32
    SRCS
      main.cc
      ${WIN32_ICON_O}
    DEPENDS
      base_exceptions
      widelands_ball_of_mud
      build_info
  )
else()
  wl_binary(widelands
    SRCS
      main.cc
    DEPENDS
      base
      base_exceptions
      base_time_string
      logic_filesystem_constants
      widelands_ball_of_mud
      build_info
  )
endif()

if(OPTION_FORCE_EMBEDDED_MINIZIP)
    # unset these two if they are cached
    unset(MINIZIP_FOUND)
    set(MINIZIP_STATIC_LIBRARIES "")
else()
   # If pkg-config is ever needed to find other libraries, move the include outside the if() block
  include(FindPkgConfig)
  if(PKG_CONFIG_FOUND)
    pkg_check_modules(MINIZIP minizip)
  endif()
endif()

add_subdirectory(third_party)
add_subdirectory(ai)
add_subdirectory(base)
add_subdirectory(chat)
add_subdirectory(commands)
add_subdirectory(economy)
add_subdirectory(editor)
add_subdirectory(game_io)
add_subdirectory(graphic)
add_subdirectory(io)
add_subdirectory(logic)
add_subdirectory(map_io)
add_subdirectory(network)
add_subdirectory(notifications)
add_subdirectory(scripting)
add_subdirectory(sound)
add_subdirectory(ui_basic)
add_subdirectory(ui_fsmenu)
if (OPTION_BUILD_WEBSITE_TOOLS)
  add_subdirectory(website)
endif (OPTION_BUILD_WEBSITE_TOOLS)
add_subdirectory(wui)

# TODO(unknown): Ideally widelands_ball_of_mud shouldn't exist, everything should be in a
# library.
wl_library(widelands_ball_of_mud
  SRCS
    wlapplication.cc
    wlapplication.h
    wlapplication_messages.cc
    wlapplication_messages.h
  USES_ATOMIC
  USES_SDL2
  USES_SDL2_TTF
  DEPENDS
    base
    base_exceptions
    base_geometry
    base_macros
    base_random
    base_time_string
    build_info
    editor
    graphic
    graphic_fonthandler
    graphic_functions
    graphic_mouse_cursor
    graphic_text
    io_filesystem
    logic
    logic_addons
    logic_exceptions
    logic_filesystem_constants
    logic_game_controller
    logic_game_settings
    logic_map
    logic_single_player_game_settings
    map_io_map_loader
    network
    sound
    ui_basic
    ui_fsmenu
    widelands_options
    wui
    wui_chat_ui
    wui_common_mapdetails
)

wl_library(widelands_options
  SRCS
    wlapplication_options.cc
    wlapplication_options.h
    wlapplication_mousewheel_options.cc
    wlapplication_mousewheel_options.h
  DEPENDS
    base
    base_geometry
    graphic_text_layout
    io_filesystem
    io_profile
    logic_filesystem_constants
  USES_SDL2
)

if (CMAKE_SYSTEM_NAME MATCHES "FreeBSD" OR
    CMAKE_SYSTEM_NAME MATCHES "NetBSD" OR
    CMAKE_SYSTEM_NAME MATCHES "OpenBSD")
  target_link_libraries(widelands_ball_of_mud ${EXECINFO_LIBRARY})
endif (CMAKE_SYSTEM_NAME MATCHES "FreeBSD" OR
       CMAKE_SYSTEM_NAME MATCHES "NetBSD" OR
       CMAKE_SYSTEM_NAME MATCHES "OpenBSD")

if (WIN32)
  target_link_libraries(widelands_ball_of_mud wsock32)
#  set_target_properties(widelands PROPERTIES LINK_FLAGS_RELEASE -s)
endif (WIN32)

=== xdg/CMakeLists.txt ===
# GNUInstallDirs requires CMake >= 3.0.2
#include(GNUInstallDirs)

set(XDG_APPLICATION_ID "org.widelands.Widelands")

list(APPEND icon_sizes "16" "32" "48" "64" "128")
foreach (icon_size ${icon_sizes})
  #install(FILES ${CMAKE_SOURCE_DIR}/data/images/logos/wl-ico-${icon_size}.png DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/${icon_size}x${icon_size}/apps RENAME ${XDG_APPLICATION_ID}.png)
  install(FILES ${CMAKE_SOURCE_DIR}/data/images/logos/wl-ico-${icon_size}.png DESTINATION ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/${icon_size}x${icon_size}/apps RENAME ${XDG_APPLICATION_ID}.png)
endforeach (icon_size ${icon_sizes})
#install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/${CMAKE_PROJECT_NAME}.6            DESTINATION ${CMAKE_INSTALL_MANDIR}/man6)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/${CMAKE_PROJECT_NAME}.6            DESTINATION ${CMAKE_INSTALL_PREFIX}/share/man/man6)
#install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/${XDG_APPLICATION_ID}.desktop      DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/${XDG_APPLICATION_ID}.desktop      DESTINATION ${CMAKE_INSTALL_PREFIX}/share/applications)
#install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/${XDG_APPLICATION_ID}.metainfo.xml DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/metainfo)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/${XDG_APPLICATION_ID}.metainfo.xml DESTINATION ${CMAKE_INSTALL_PREFIX}/share/metainfo)

# TODO: check for privileges
# If 'make install' was run without superuser privileges, the user will get a "permission denied" error
# when 'gtk-update-icon-cache' is executed
find_program(GTK_UPDATE_ICON_CACHE NAMES gtk-update-icon-cache)
if (GTK_UPDATE_ICON_CACHE)
  #install(CODE "execute_process (COMMAND ${GTK_UPDATE_ICON_CACHE} -t -f ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor ||: )")
  install(CODE "execute_process (COMMAND ${GTK_UPDATE_ICON_CACHE} -t -f ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor ||: )")
else (GTK_UPDATE_ICON_CACHE)
  message(WARNING "gtk-update-icon-cache not found!")
endif (GTK_UPDATE_ICON_CACHE)

=== src/ai/CMakeLists.txt ===
add_subdirectory(test)

wl_library(ai_hints
  SRCS
    ai_hints.cc
    ai_hints.h
  DEPENDS
    base
    base_macros
    logic_constants
    logic_exceptions
    scripting_lua_table
)

wl_library(ai
  SRCS
    ai_help_structs.cc
    ai_help_structs.h
    computer_player.cc
    computer_player.h
    defaultai_seafaring.cc
    defaultai_warfare.cc
    defaultai.cc
    defaultai.h
  DEPENDS
    ai_hints
    base
    base_exceptions
    base_macros
    base_time_string
    economy
    logic
    logic_constants
    commands
    logic_game_controller
    logic_map
    logic_map_objects
)

=== src/base/CMakeLists.txt ===
add_subdirectory(test)

wl_library(base
  SRCS
    format/abstract_node.h
    format/boolean_node.h
    format/common_nodes.h
    format/float_node.h
    format/number_node.h
    format/string_node.h
    format/tree.cc
    format/tree.h
    format/wildcard_node.h
    format/write_number.h
    i18n.h
    i18n.cc
    multithreading.h
    multithreading.cc
    mutex.h
    log.cc
    log.h
    string.h
    string.cc
  USES_ATOMIC
  USES_SDL2
  USES_TINYGETTEXT
  DEPENDS
    base_exceptions
    base_macros
    base_times
    build_info
    io_filesystem
    logic_filesystem_constants
    notifications
)

wl_library(base_macros
  SRCS
    macros.h
    macros.cc
)

wl_library(base_exceptions
  SRCS
    exceptions.cc
    warning.h
    wexception.h
  DEPENDS
    base_macros
)

wl_library(base_utf8
  SRCS
    utf8.h
    utf8.cc
)

wl_library(base_geometry
  SRCS
    rect.h
    vector.h
    vector.cc
)

wl_library(base_crypto
  SRCS
    crypto.cc
    crypto.h
  DEPENDS
    third_party_libmd
)

wl_library(base_random
  SRCS
    random.h
    random.cc
  DEPENDS
    io_stream
    base_exceptions
)


wl_library(base_scoped_timer
  SRCS
    scoped_timer.h
    scoped_timer.cc
  USES_SDL2
  DEPENDS
    base
    base_macros
)


wl_library(base_time_string
  SRCS
    time_string.h
    time_string.cc
  DEPENDS
    base
)


wl_library(base_times
  SRCS
    times.h
    times.cc
  USES_ATOMIC
  DEPENDS
    base_exceptions
    io_fileread
)


wl_library(base_math
  SRCS
    math.h
    math.cc
  DEPENDS
    base_exceptions
)

wl_library(base_test
  SRCS
    test.h
    test.cc
  DEPENDS
    base
    base_exceptions
)

=== src/commands/CMakeLists.txt ===
wl_library(commands
  SRCS
    cmd_act.cc
    cmd_act.h
    cmd_attack.cc
    cmd_attack.h
    cmd_build_building.cc
    cmd_build_building.h
    cmd_build_flag.cc
    cmd_build_flag.h
    cmd_building_name.cc
    cmd_building_name.h
    cmd_build_road.cc
    cmd_build_road.h
    cmd_build_waterway.cc
    cmd_build_waterway.h
    cmd_bulldoze.cc
    cmd_bulldoze.h
    cmd_calculate_statistics.cc
    cmd_calculate_statistics.h
    cmd_call_economy_balance.cc
    cmd_call_economy_balance.h
    cmd_change_soldier_capacity.cc
    cmd_change_soldier_capacity.h
    cmd_change_training_options.cc
    cmd_change_training_options.h
    cmd_delete_message.cc
    cmd_delete_message.h
    cmd_destroy_map_object.cc
    cmd_destroy_map_object.h
    cmd_diplomacy.cc
    cmd_diplomacy.h
    cmd_dismantle_building.cc
    cmd_dismantle_building.h
    cmd_drop_soldier.cc
    cmd_drop_soldier.h
    cmd_enhance_building.cc
    cmd_enhance_building.h
    cmd_evict_worker.cc
    cmd_evict_worker.h
    cmd_expedition_config.cc
    cmd_expedition_config.h
    cmd_extend_trade.cc
    cmd_extend_trade.h
    cmd_flag_action.cc
    cmd_flag_action.h
    cmd_fleet_targets.cc
    cmd_fleet_targets.h
    cmd_incorporate.cc
    cmd_incorporate.h
    cmd_luacoroutine.cc
    cmd_luacoroutine.h
    cmd_luascript.cc
    cmd_luascript.h
    cmd_mark_map_object_for_removal.cc
    cmd_mark_map_object_for_removal.h
    cmd_message_set_status_archived.cc
    cmd_message_set_status_archived.h
    cmd_message_set_status_read.cc
    cmd_message_set_status_read.h
    cmd_net_check_sync.cc
    cmd_net_check_sync.h
    cmd_pick_custom_starting_position.cc
    cmd_pick_custom_starting_position.h
    cmd_pinned_note.cc
    cmd_pinned_note.h
    cmd_propose_trade.cc
    cmd_propose_trade.h
    cmd_queue.cc
    cmd_queue.h
    cmd_replay_end.cc
    cmd_replay_end.h
    cmd_replay_sync_read.cc
    cmd_replay_sync_read.h
    cmd_replay_sync_write.cc
    cmd_replay_sync_write.h
    cmd_set_input_max_fill.cc
    cmd_set_input_max_fill.h
    cmd_set_soldier_preference.cc
    cmd_set_soldier_preference.h
    cmd_set_stock_policy.cc
    cmd_set_stock_policy.h
    cmd_set_ware_priority.cc
    cmd_set_ware_priority.h
    cmd_set_ware_target_quantity.cc
    cmd_set_ware_target_quantity.h
    cmd_set_worker_target_quantity.cc
    cmd_set_worker_target_quantity.h
    cmd_ship_cancel_expedition.cc
    cmd_ship_cancel_expedition.h
    cmd_ship_construct_port.cc
    cmd_ship_construct_port.h
    cmd_ship_explore_island.cc
    cmd_ship_explore_island.h
    cmd_ship_refit.cc
    cmd_ship_refit.h
    cmd_ship_scout_direction.cc
    cmd_ship_scout_direction.h
    cmd_ship_set_destination.cc
    cmd_ship_set_destination.h
    cmd_ship_sink.cc
    cmd_ship_sink.h
    cmd_start_or_cancel_expedition.cc
    cmd_start_or_cancel_expedition.h
    cmd_start_stop_building.cc
    cmd_start_stop_building.h
    cmd_toggle_infinite_production.cc
    cmd_toggle_infinite_production.h
    cmd_toggle_mute_messages.cc
    cmd_toggle_mute_messages.h
    cmd_trade_action.cc
    cmd_trade_action.h
    cmd_warship_command.cc
    cmd_warship_command.h
    command.cc
    command.h
    queue_cmd_ids.cc
    queue_cmd_ids.h
  DEPENDS
    base
    base_crypto
    base_exceptions
    base_macros
    base_times
    build_info
    economy # TODO(GunChleoc): Circular dependency
    graphic_color
    graphic_text_layout
    io_fileread
    logic # TODO(GunChleoc): Circular dependency
    logic_constants
    logic_exceptions
    logic_game_controller
    logic_map
    logic_map_objects
    logic_widelands_geometry
    logic_widelands_geometry_io
    map_io
    scripting_coroutine
    scripting_logic # TODO(GunChleoc): Circular dependency
    scripting_lua_table
    ui_basic
    wui
)

=== src/economy/CMakeLists.txt ===
wl_library(economy
  SRCS
    economy.cc
    economy.h
    economy_data_packet.cc
    economy_data_packet.h
    expedition_bootstrap.cc
    expedition_bootstrap.h
    ferry_fleet.cc
    ferry_fleet.h
    flag.cc
    flag.h
    flag_job.h
    idleworkersupply.cc
    idleworkersupply.h
    iroute.h
    itransport_cost_calculator.h
    portdock.cc
    portdock.h
    request.cc
    request.h
    roadbase.cc
    roadbase.h
    road.cc
    road.h
    route.cc
    route.h
    routeastar.cc
    routeastar.h
    router.cc
    router.h
    routing_node.h
    ship_fleet.cc
    ship_fleet.h
    shippingitem.cc
    shippingitem.h
    shipping_schedule.cc
    shipping_schedule.h
    soldier_request.cc
    soldier_request.h
    supply.h
    supply_list.cc
    supply_list.h
    trackptr.h
    transfer.cc
    transfer.h
    ware_instance.cc
    ware_instance.h
    warehousesupply.h
    input_queue.cc
    input_queue.h
    ware_priority.cc
    ware_priority.h
    wares_queue.cc
    wares_queue.h
    waterway.cc
    waterway.h
    workers_queue.cc
    workers_queue.h
  DEPENDS
    base
    base_exceptions
    base_macros
    base_times
    graphic
    io_fileread
    io_stream
    logic
    commands
    logic_constants
    logic_exceptions
    logic_map
    logic_map_objects
    logic_widelands_geometry
    logic_widelands_geometry_io
    map_io
    notifications
)
add_subdirectory(test)

=== src/editor/CMakeLists.txt ===
wl_library(editor
  SRCS
    editorinteractive.cc
    editorinteractive.h
    editor_category.cc
    editor_category.h
    map_generator.cc
    map_generator.h
    tools/action_args.h
    tools/decrease_height_tool.cc
    tools/decrease_height_tool.h
    tools/decrease_resources_tool.cc
    tools/decrease_resources_tool.h
    tools/delete_critter_tool.cc
    tools/delete_critter_tool.h
    tools/delete_immovable_tool.cc
    tools/delete_immovable_tool.h
    tools/draw_tool.cc
    tools/draw_tool.h
    tools/history.cc
    tools/history.h
    tools/increase_height_tool.cc
    tools/increase_height_tool.h
    tools/increase_resources_tool.cc
    tools/increase_resources_tool.h
    tools/info_tool.cc
    tools/info_tool.h
    tools/multi_select.h
    tools/noise_height_tool.cc
    tools/noise_height_tool.h
    tools/place_critter_tool.cc
    tools/place_critter_tool.h
    tools/place_immovable_tool.cc
    tools/place_immovable_tool.h
    tools/resize_tool.cc
    tools/resize_tool.h
    tools/set_height_tool.cc
    tools/set_height_tool.h
    tools/set_origin_tool.cc
    tools/set_origin_tool.h
    tools/set_port_space_tool.cc
    tools/set_port_space_tool.h
    tools/set_resources_tool.cc
    tools/set_resources_tool.h
    tools/set_starting_pos_tool.cc
    tools/set_starting_pos_tool.h
    tools/set_terrain_tool.cc
    tools/set_terrain_tool.h
    tools/tool.h
    tools/tool_action.h
    tools/tool_conf.cc
    tools/tool_conf.h
    tools/toolhistory_tool.cc
    tools/toolhistory_tool.h
    ui_menus/categorized_item_selection_menu.h
    ui_menus/field_info_window.h
    ui_menus/field_info_window.cc
    ui_menus/help.cc
    ui_menus/help.h
    ui_menus/main_menu_load_map.cc
    ui_menus/main_menu_load_map.h
    ui_menus/main_menu_load_or_save_map.cc
    ui_menus/main_menu_load_or_save_map.h
    ui_menus/main_menu_map_options.cc
    ui_menus/main_menu_map_options.h
    ui_menus/main_menu_new_map.cc
    ui_menus/main_menu_new_map.h
    ui_menus/main_menu_random_map.cc
    ui_menus/main_menu_random_map.h
    ui_menus/main_menu_save_map.cc
    ui_menus/main_menu_save_map.h
    ui_menus/main_menu_save_map_make_directory.cc
    ui_menus/main_menu_save_map_make_directory.h
    ui_menus/map_size_box.cc
    ui_menus/map_size_box.h
    ui_menus/player_menu.cc
    ui_menus/player_menu.h
    ui_menus/tool_change_height_options_menu.cc
    ui_menus/tool_change_height_options_menu.h
    ui_menus/tool_change_resources_options_menu.cc
    ui_menus/tool_change_resources_options_menu.h
    ui_menus/tool_noise_height_options_menu.cc
    ui_menus/tool_noise_height_options_menu.h
    ui_menus/tool_options_menu.cc
    ui_menus/tool_options_menu.h
    ui_menus/tool_place_critter_options_menu.cc
    ui_menus/tool_place_critter_options_menu.h
    ui_menus/tool_place_immovable_options_menu.cc
    ui_menus/tool_place_immovable_options_menu.h
    ui_menus/tool_resize_options_menu.cc
    ui_menus/tool_resize_options_menu.h
    ui_menus/tool_set_terrain_options_menu.cc
    ui_menus/tool_set_terrain_options_menu.h
    ui_menus/tool_toolhistory_options_menu.cc
    ui_menus/tool_toolhistory_options_menu.h
    ui_menus/toolsize_menu.cc
    ui_menus/toolsize_menu.h
  USES_SDL2
  DEPENDS
    base
    base_exceptions
    base_macros
    base_random
    base_scoped_timer
    build_info
    graphic
    graphic_color_palette
    graphic_fonthandler
    graphic_mouse_cursor
    graphic_playercolor
    graphic_surface
    graphic_text_layout
    io_filesystem
    io_filesystem_illegal_filename_check
    logic
    logic_addons
    logic_constants
    logic_exceptions
    logic_filesystem_constants
    logic_generic_save_handler
    logic_map
    logic_map_object_type
    logic_map_objects
    logic_map_objects_description_maintainer
    logic_single_player_game_settings
    logic_tribe_basic_info
    logic_widelands_geometry
    map_io
    map_io_map_loader
    network
    scripting_lua_interface
    scripting_lua_table
    sound
    ui_addons
    ui_basic
    widelands_options
    wui
    wui_common_mapdetails
)

=== src/graphic/CMakeLists.txt ===
add_subdirectory(animation)
add_subdirectory(styles)
add_subdirectory(text)

# TODO(sirver): Separate this directory into a base directory and one
# that is Widelands aware (can include logic stuff).

# Align and color

wl_library(graphic_toolbar_imageset
  SRCS
    toolbar_imageset.cc
    toolbar_imageset.h
  DEPENDS
    graphic
    graphic_surface
    scripting_lua_table
)

wl_library(graphic_align
  SRCS
    align.h
    align.cc
  DEPENDS
    base_geometry
    base_exceptions
)

wl_library(graphic_color
  SRCS
    color.h
    color.cc
  DEPENDS
    base
  USES_SDL2
)

wl_library(graphic_color_palette
  SRCS
    color_palette.h
    color_palette.cc
  DEPENDS
    base
    base_exceptions
    graphic_color
)

wl_library(graphic_playercolor
  SRCS
    playercolor.cc
    playercolor.h
  DEPENDS
    base
    graphic
    graphic_color
    graphic_surface
    io_filesystem
)


# Rendering utils

wl_library(graphic_build_texture_atlas
  SRCS
    build_texture_atlas.h
    build_texture_atlas.cc
  DEPENDS
    base
    graphic
    graphic_image_io
    graphic_surface
    graphic_texture_atlas
    io_filesystem
    io_profile
    logic_filesystem_constants
)

wl_library(graphic_image_io
  SRCS
    image_io.h
    image_io.cc
  USES_PNG
  USES_SDL2_IMAGE
  DEPENDS
    base_exceptions
    graphic_surface
    io_fileread
    io_filesystem
    io_stream
)

wl_library(graphic_sdl_utils
  SRCS
    sdl_utils.h
    sdl_utils.cc
  USES_SDL2
)

wl_library(graphic_gl_utils
  SRCS
    gl/blit_data.h
    gl/coordinate_conversion.h
    gl/initialize.cc
    gl/initialize.h
    gl/system_headers.h
    gl/utils.cc
    gl/utils.h
  USES_SDL2
  USES_OPENGL
  DEPENDS
    base
    base_exceptions
    base_geometry
    base_macros
    graphic_text
    io_fileread
    io_filesystem
)

wl_library(graphic_surface
  SRCS
    image.h
    screen.cc
    screen.h
    surface.cc
    surface.h
    texture.cc
    texture.h
  USES_SDL2
  DEPENDS
    base
    base_exceptions
    base_geometry
    base_macros
    graphic_color
    graphic_draw_programs
    graphic_gl_utils
    graphic_render_queue
    graphic_sdl_utils
)

wl_library(graphic_texture_atlas
  SRCS
    texture_atlas.h
    texture_atlas.cc
  DEPENDS
    base_exceptions
    base_macros
    graphic_surface
)

wl_library(graphic_draw_programs
  SRCS
    blend_mode.h
    blit_mode.h
    gl/blit_program.cc
    gl/blit_program.h
    gl/draw_line_program.cc
    gl/draw_line_program.h
    gl/fill_rect_program.cc
    gl/fill_rect_program.h
  DEPENDS
    base_exceptions
    base_macros
    base_math
    base_geometry
    graphic_fields_to_draw
    graphic_gl_utils
    graphic_color
)


# Logic-aware stuff

wl_library(graphic_render_queue
  SRCS
    render_queue.cc
    render_queue.h
  DEPENDS
    base_exceptions
    base_geometry
    base_macros
    graphic_color
    graphic_draw_programs
    graphic_fields_to_draw
    graphic_terrain_programs
    logic_map_objects
    logic_map_objects_description_maintainer
)

wl_library(graphic_game_renderer
  SRCS
    game_renderer.cc
    game_renderer.h
  DEPENDS
    graphic
    graphic_fields_to_draw
    graphic_render_queue
    graphic_surface
    logic
    logic_map_objects
)

wl_library(graphic_minimap_renderer
  SRCS
    minimap_renderer.cc
    minimap_renderer.h
  USES_SDL2
  DEPENDS
    base_geometry
    economy
    graphic_playercolor
    graphic_surface
    logic
    logic_constants
    logic_map
    logic_map_objects
    wui_mapview_pixelfunctions
)

wl_library(graphic_fields_to_draw
  SRCS
    gl/fields_to_draw.cc
    gl/fields_to_draw.h
  DEPENDS
    base
    base_geometry
    graphic
    graphic_gl_utils
    logic
    logic_constants
    logic_map_objects
    logic_widelands_geometry
    wui_mapview_pixelfunctions
)

wl_library(graphic_terrain_programs
  SRCS
    gl/grid_program.cc
    gl/grid_program.h
    gl/road_program.cc
    gl/road_program.h
    gl/terrain_program.cc
    gl/terrain_program.h
    gl/dither_program.cc
    gl/dither_program.h
    gl/workarea_program.cc
    gl/workarea_program.h
  USES_ATOMIC
  DEPENDS
    base_exceptions
    base_geometry
    base_macros
    graphic
    graphic_fields_to_draw
    graphic_gl_utils
    graphic_image_io
    graphic_surface
    io_filesystem
    logic
    logic_map_objects
    logic_map_objects_description_maintainer
    wui_mapview_pixelconstants
)


# Font handler and text
wl_library(graphic_fonthandler
  SRCS
    font_handler.cc
    font_handler.h
  DEPENDS
    base
    base_macros
    graphic
    graphic_text
)

wl_library(graphic_text_layout
  SRCS
    text_layout.cc
    text_layout.h
  DEPENDS
    base
    graphic # TODO(Gunchleoc): For text_width safety only - rewrite that function
    graphic_align
    graphic_color
    graphic_surface
    graphic_styles
    graphic_text
    graphic_fonthandler
)

wl_library(graphic_wordwrap
  SRCS
    wordwrap.cc
    wordwrap.h
  USES_ICU
  DEPENDS
    base
    base_geometry
    graphic
    graphic_align
    graphic_color
    graphic_fonthandler
    graphic_text
    graphic_text_layout
)


# Mouse cursor

wl_library(graphic_mouse_cursor
  SRCS
    mouse_cursor.cc
    mouse_cursor.h
  USES_SDL2
  DEPENDS
    base_geometry
    graphic
    graphic_image_io
    io_filesystem
)


# Misc high-level helper and convenience functions

wl_library(graphic_functions
  SRCS
    graphic_functions.cc
    graphic_functions.h
  DEPENDS
    graphic
    graphic_fonthandler
    graphic_text_layout
    widelands_options
)

# Base library

wl_library(graphic
  SRCS
    default_resolution.h
    graphic.cc
    graphic.h
    note_graphic_resolution_changed.h
    hyperlink.h
    image_cache.cc
    image_cache.h
    style_manager.cc
    style_manager.h
    rendertarget.cc
    rendertarget.h
    road_segments.cc
    road_segments.h
  USES_SDL2
  DEPENDS
    base
    base_exceptions
    base_geometry
    base_macros
    base_scoped_timer
    base_times
    build_info
    graphic_align
    graphic_animation
    graphic_build_texture_atlas
    graphic_color
    graphic_draw_programs
    graphic_gl_utils
    graphic_image_io
    graphic_render_queue
    graphic_styles
    graphic_surface
    io_filesystem
    io_stream
    logic_widelands_geometry
    notifications
    scripting_lua_interface
    scripting_lua_table
)

=== src/logic/CMakeLists.txt ===
wl_library(logic_exceptions
  SRCS
    game_data_error.cc
    game_data_error.h
  DEPENDS
    base
    base_exceptions
)

wl_library(logic_widelands_geometry
  SRCS
    widelands_geometry.cc
    widelands_geometry.h
)

wl_library(logic_widelands_geometry_io
  SRCS
    widelands_geometry_io.cc
    widelands_geometry_io.h
  DEPENDS
    io_fileread
    io_stream
    logic_constants
    logic_widelands_geometry
)

wl_library(logic_game_settings
  SRCS
    game_settings.cc
    game_settings.h
    player_end_result.h
  DEPENDS
    graphic_color
    io_filesystem
    logic_addons
    logic_constants
    logic_exceptions
    logic_filesystem_constants
    logic_tribe_basic_info
    notifications
    scripting_lua_interface
    scripting_lua_table
)

wl_library(logic_single_player_game_settings
  SRCS
    single_player_game_settings_provider.cc
    single_player_game_settings_provider.h
  DEPENDS
    ai
    base
    base_exceptions
    base_random
    graphic_playercolor
    logic_game_settings
    logic_tribe_basic_info
)

wl_library(logic_game_controller
  SRCS
    game_controller.h
    replay_game_controller.h
    replay_game_controller.cc
    single_player_game_controller.h
    single_player_game_controller.cc
  USES_SDL2
  DEPENDS
    ai
    base_times
    logic
    commands
    logic_game_settings
    widelands_options
    wui
)

wl_library(logic_constants
  SRCS
    vision.h
    widelands.cc
    widelands.h
  DEPENDS
    base_exceptions
)

wl_library(logic_filesystem_constants
  SRCS
    filesystem_constants.h
    filesystem_constants.cc
)

wl_library(logic_addons
  SRCS
    addons.cc
    addons.h
    mutable_addon.cc
    mutable_addon.h
  DEPENDS
    base
    base_exceptions
    base_math
    base_time_string
    build_info
    graphic
    graphic_text_layout
    io_fileread
    io_filesystem
    io_profile
    logic_filesystem_constants
    logic_map
    map_io
    map_io_map_loader
    widelands_options
)

wl_library(logic_objectives
  SRCS
    objective.cc
    objective.h
  DEPENDS
    base
)


wl_library(logic_generic_save_handler
  SRCS
    generic_save_handler.h
    generic_save_handler.cc
  DEPENDS
    base
    base_time_string
    io_filesystem
    logic_filesystem_constants
)

wl_library(logic_map
  SRCS
    cookie_priority_queue.h
    field.cc
    field.h
    map.cc
    map.h
    map_compassdir.cc
    map_compassdir.h
    map_revision.cc
    map_revision.h
    mapastar.cc
    mapastar.h
    mapdifferenceregion.cc
    mapdifferenceregion.h
    mapfringeregion.cc
    mapfringeregion.h
    maphollowregion.cc
    maphollowregion.h
    mapregion.h
    maptriangleregion.cc
    maptriangleregion.h
    nodecaps.h
    note_map_options.h
    path.cc
    path.h
    pathfield.cc
    pathfield.h
  USES_ATOMIC
  DEPENDS
    base
    base_exceptions
    base_macros
    base_scoped_timer
    build_info
    economy
    graphic
    graphic_playercolor
    io_fileread
    io_filesystem
    logic
    logic_addons
    logic_constants
    logic_exceptions
    logic_filesystem_constants
    logic_map_objects
    logic_objectives
    logic_widelands_geometry
    logic_widelands_geometry_io
    map_io_map_loader
    notifications
    wui_mapview_pixelconstants
)

wl_library(logic_training_wheels
  SRCS
    training_wheels.cc
    training_wheels.h
  DEPENDS
    base
    io_filesystem
    io_profile
    logic_filesystem_constants
    scripting_lua_table
    scripting_lua_interface
)

wl_library(logic
  SRCS
    ai_dna_handler.cc
    ai_dna_handler.h
    detected_port_space.cc
    detected_port_space.h
    editor_game_base.cc
    editor_game_base.h
    game.cc
    game.h
    message.h
    message_id.h
    message_queue.h
    player.cc
    player.h
    player_area.h
    playersmanager.cc
    playersmanager.h
    replay.cc
    replay.h
    save_handler.cc
    save_handler.h
    trade_agreement.h
  # TODO(sirver): Uses SDL2 only on WIN32 for a dirty hack.
  USES_SDL2
  USES_ATOMIC
  DEPENDS
    base
    base_crypto
    base_exceptions
    base_macros
    base_random
    base_scoped_timer
    base_time_string
    base_times
    build_info
    economy
    game_io
    graphic
    graphic_color
    graphic_playercolor
    io_fileread
    io_filesystem
    io_profile
    io_stream
    logic_addons
    commands
    logic_constants
    logic_exceptions
    logic_filesystem_constants
    logic_game_controller
    logic_game_settings
    logic_generic_save_handler
    logic_map
    logic_map_objects
    logic_tribe_basic_info
    logic_training_wheels
    logic_widelands_geometry
    map_io
    map_io_map_loader
    note_sound
    notifications
    scripting_logic # TODO(GunChleoc): Circular dependency
    scripting_lua_interface
    scripting_lua_table
    sound
    sound_constants
    ui_basic
    ui_basic_loading_message
    widelands_options
    wui # TODO(GunChleoc): Circular dependency
    wui_game_tips
)

add_subdirectory(map_objects)

=== src/network/CMakeLists.txt ===
wl_library(network
  SRCS
    bufferedconnection.cc
    bufferedconnection.h
    constants.h
    internet_gaming.cc
    internet_gaming.h
    internet_gaming_messages.cc
    internet_gaming_messages.h
    internet_gaming_protocol.h
    gameclient.cc
    gameclient.h
    gamehost.cc
    gamehost.h
    host_game_settings_provider.cc
    host_game_settings_provider.h
    net_addons.cc
    net_addons.h
    netclient_interface.h
    netclient.cc
    netclient.h
    netclientproxy.cc
    netclientproxy.h
    nethost_interface.h
    nethost.cc
    nethost.h
    nethostproxy.cc
    nethostproxy.h
    network.cc
    network.h
    network_gaming_messages.cc
    network_gaming_messages.h
    network_lan_promotion.cc
    network_lan_promotion.h
    network_player_settings_backend.cc
    network_player_settings_backend.h
    network_protocol.h
    relay_protocol.h
    participantlist.cc
    participantlist.h
  USES_SDL2
  DEPENDS
    ai
    base
    base_crypto
    base_exceptions
    base_macros
    base_math
    base_random
    base_time_string
    build_info
    chat
    game_io
    graphic
    io_fileread
    io_filesystem
    io_stream
    logic
    logic_addons
    commands
    logic_constants
    logic_filesystem_constants
    logic_game_controller
    logic_game_settings
    logic_tribe_basic_info
    map_io_map_loader
    notifications
    scripting_lua_interface
    scripting_lua_table
    ui_basic
    ui_fsmenu
    widelands_ball_of_mud
    widelands_options
    wui
)

=== src/sound/CMakeLists.txt ===
wl_library(note_sound
  SRCS
    note_sound.h
    note_sound.cc
  DEPENDS
    logic_widelands_geometry
    notifications
    sound_constants
)

wl_library(sound_constants
  SRCS
    constants.cc
    constants.h
)

wl_library(sound
  SRCS
    fxset.cc
    fxset.h
    song.cc
    song.h
    songset.cc
    songset.h
    sound_handler.cc
    sound_handler.h
  USES_SDL2
  USES_SDL2_MIXER
  DEPENDS
    base
    base_macros
    base_random
    io_fileread
    io_filesystem
    logic_exceptions
    sound_constants
    widelands_options
)

=== src/ui_basic/CMakeLists.txt ===
wl_library(ui_basic_loading_message
  SRCS
    note_loading_message.cc
    note_loading_message.h
  DEPENDS
    notifications
)

wl_library(ui_basic
  SRCS
    box.cc
    box.h
    button.cc
    button.h
    checkbox.cc
    checkbox.h
    color_chooser.cc
    color_chooser.h
    dropdown.cc
    dropdown.h
    fileview_panel.cc
    fileview_panel.h
    icon.cc
    icon.h
    icongrid.cc
    icongrid.h
    infinite_spinner.cc
    infinite_spinner.h
    listselect.cc
    listselect.h
    messagebox.cc
    messagebox.h
    mouse_constants.h
    multilinetextarea.cc
    multilinetextarea.h
    pagination.cc
    pagination.h
    panel.cc
    panel.h
    progressbar.cc
    progressbar.h
    progresswindow.cc
    progresswindow.h
    radiobutton.cc
    radiobutton.h
    scrollbar.cc
    scrollbar.h
    slider.cc
    slider.h
    spinbox.cc
    spinbox.h
    table.cc
    table.h
    tabpanel.cc
    tabpanel.h
    textarea.cc
    textarea.h
    textinput.cc
    textinput.h
    text_prompt.cc
    text_prompt.h
    toolbar_setup.cc
    toolbar_setup.h
    unique_window.cc
    unique_window.h
    window.cc
    window.h
  USES_SDL2
  USES_ATOMIC
  DEPENDS
    base
    base_exceptions
    base_geometry
    base_macros
    base_math
    base_random
    base_utf8
    graphic
    graphic_align
    graphic_color
    graphic_fonthandler
    graphic_functions
    graphic_mouse_cursor
    graphic_playercolor
    graphic_styles
    graphic_surface
    graphic_text
    graphic_text_layout
    graphic_wordwrap
    io_fileread
    io_filesystem
    notifications
    scripting_lua_interface
    scripting_lua_table
    sound
    sound_constants
    widelands_ball_of_mud
    widelands_options
)

=== debian/changelog ===
widelands (2:1.3-2) unstable; urgency=medium

  * Team upload.
  * Source-Only upload to allow testing migration. Closes: #1126319.
  * Remove obsolete lintian warnings about line length.
  * Update S-V to 4.7.3:
    - drop Priority from d/control, it now defaults to optional and
      Policy recommends to stop specifying it.
  * Bump debian/copyright years.
  * Fix lintian warning about inconsistent appstream-metadata license
    information by correcting d/copyright.

 -- Tobias Frost <tobi@debian.org>  Sat, 24 Jan 2026 13:12:52 +0100

widelands (2:1.3-1) unstable; urgency=medium

  * New upstream release.
  * Drop d/p/FTBFS-GCC15: applied upstream.

 -- Martin Quinson <mquinson@debian.org>  Tue, 23 Dec 2025 12:05:37 +0100

widelands (2:1.2.1-4) unstable; urgency=medium

  * d/p/FTBFS-GCC15: upstream patch to fix a FTBFS with GCC 15 
    (Closes: #1098093).

 -- Martin Quinson <mquinson@debian.org>  Sat, 11 Oct 2025 21:42:06 +0200

=== debian/control ===
Source: widelands
Section: games
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
  Martin Quinson <mquinson@debian.org>,
Standards-Version: 4.7.3
Build-Depends: debhelper-compat (= 13),
  cmake,
  libasio-dev,
  libminizip-dev,
  libboost-dev,
  libboost-regex-dev,
  libboost-test-dev,
  libboost-system-dev,
  libcurl4-gnutls-dev,
  libglew-dev,
  libmd-dev,
  libpng-dev,
  libsdl2-dev,
  libsdl2-image-dev,
  libsdl2-mixer-dev,
  libsdl2-ttf-dev,
  python3,
  zlib1g-dev
Vcs-Git: https://salsa.debian.org/games-team/widelands.git
Vcs-Browser: https://salsa.debian.org/games-team/widelands
Homepage: http://www.widelands.org/
Rules-Requires-Root: no

Package: widelands
Architecture: any
Depends: widelands-data (= ${source:Version}),
  ${shlibs:Depends},
  ${misc:Depends},
Description: fantasy real-time strategy game
 Widelands is a strategy game aiming for gameplay similar to Settlers II by
 BlueByte.
 .
 In this game, you start out on a small piece of land with nothing more than
 a few of useful resources. Using those, you can build yourself an empire
 with many thousands of inhabitants. On your way towards this goal, you will
 have to build up an economic infrastructure, explore the lands around you
 and face enemies who are trying to rule the world just like you do.

Package: widelands-data
Architecture: all
Depends: fonts-freefont-ttf,
  fonts-dejavu-core,
  fonts-dejavu-extra,
  fonts-hosny-amiri,
  fonts-nakula,
  fonts-wqy-microhei,
  fonts-culmus-fancy,
  ${misc:Depends}
Description: fantasy real-time strategy game (data files)
 This package contains the graphics and levels for Widelands.
 .
 Widelands is a strategy game aiming for gameplay similar to Settlers II by
 BlueByte.
 .
 In this game, you start out on a small piece of land with nothing more than
 a few of useful resources. Using those, you can build yourself an empire
 with many thousands of inhabitants. On your way towards this goal, you will
 have to build up an economic infrastructure, explore the lands around you
 and face enemies who are trying to rule the world just like you do.

## widelands 1.3.1

=== src/game_io/CMakeLists.txt ===
wl_library(game_io
  SRCS
    game_cmd_queue_packet.cc
    game_cmd_queue_packet.h
    game_data_packet.h
    game_class_packet.cc
    game_class_packet.h
    game_interactive_player_packet.cc
    game_interactive_player_packet.h
    game_player_ai_persistent_packet.cc
    game_player_ai_persistent_packet.h
    game_loader.cc
    game_loader.h
    game_map_packet.cc
    game_map_packet.h
    game_player_economies_packet.cc
    game_player_economies_packet.h
    game_player_info_packet.cc
    game_player_info_packet.h
    game_player_trades_packet.cc
    game_player_trades_packet.h
    game_preload_packet.cc
    game_preload_packet.h
    game_saver.cc
    game_saver.h
  DEPENDS
    base
    base_exceptions
    base_macros
    base_scoped_timer
    base_times
    build_info
    economy
    graphic_image_io
    graphic_minimap_renderer
    io_fileread
    io_filesystem
    io_profile
    logic
    logic_addons
    commands
    logic_exceptions
    logic_game_controller
    logic_map
    logic_map_objects
    logic_widelands_geometry_io
    map_io
    map_io_map_loader
    scripting_lua_table
    ui_basic
    wui
    wui_mapview
    wui_mapview_pixelfunctions
)

=== src/third_party/CMakeLists.txt ===
if (NOT MINIZIP_STATIC_LIBRARIES)
  wl_library(third_party_minizip
    THIRD_PARTY
    SRCS
      minizip/ioapi.h
      minizip/unzip.cc
      minizip/unzip.h
      minizip/zip.h
    USES_ZLIB
  )
  message(STATUS "Using embedded minizip libraries")
endif()

wl_library(third_party_eris
  THIRD_PARTY
  C_LIBRARY
  SRCS
    eris/eris.c
    eris/eris.h
    eris/lapi.c
    eris/lapi.h
    eris/lauxlib.c
    eris/lauxlib.h
    eris/lbaselib.c
    eris/lbitlib.c
    eris/lcode.c
    eris/lcode.h
    eris/lcorolib.c
    eris/lctype.c
    eris/lctype.h
    eris/ldblib.c
    eris/ldebug.c
    eris/ldebug.h
    eris/ldo.c
    eris/ldo.h
    eris/ldump.c
    eris/lfunc.c
    eris/lfunc.h
    eris/lgc.c
    eris/lgc.h
    eris/linit.c
    eris/liolib.c
    eris/llex.c
    eris/llex.h
    eris/llimits.h
    eris/lmathlib.c
    eris/lmem.c
    eris/lmem.h
    eris/loadlib.c
    eris/lobject.c
    eris/lobject.h
    eris/lopcodes.c
    eris/lopcodes.h
    eris/loslib.c
    eris/lparser.c
    eris/lparser.h
    eris/lprefix.h
    eris/lstate.c
    eris/lstate.h
    eris/lstring.c
    eris/lstring.h
    eris/lstrlib.c
    eris/ltable.c
    eris/ltable.h
    eris/ltablib.c
    eris/ltm.c
    eris/ltm.h
    eris/lua.h
    eris/lua.hpp
    eris/lua.c
    eris/luac.c
    eris/luaconf.h
    eris/lualib.h
    eris/lundump.c
    eris/lundump.h
    eris/lutf8lib.c
    eris/lvm.c
    eris/lvm.h
    eris/lzio.c
    eris/lzio.h
)

wl_library(third_party_libmd
  THIRD_PARTY_WITH_INCLUDES
  SRCS
    libmd/include/md5.h
    libmd/include/sha1.h
    libmd/include/sha256.h
    libmd/include/sha2.h
    libmd/include/sha512.h
    libmd/include/sha.h
    libmd/src/helper_md5.cc
    libmd/src/helper_sha1.cc
    libmd/src/helper_sha224.cc
    libmd/src/helper_sha256.cc
    libmd/src/helper_sha384.cc
    libmd/src/helper_sha512_256.cc
    libmd/src/helper_sha512.cc
    libmd/src/md5.cc
    libmd/src/sha1.cc
    libmd/src/sha2.cc
)

add_definitions(-DTINYGETTEXT_WITH_SDL)
wl_library(tinygettext
  THIRD_PARTY
  SRCS
    tinygettext/src/dictionary.cpp
    tinygettext/src/dictionary_manager.cpp
    tinygettext/src/iconv.cpp
    tinygettext/src/language.cpp
    tinygettext/src/log.cpp
    tinygettext/src/plural_forms.cpp
    tinygettext/src/po_parser.cpp
    tinygettext/src/tinygettext.cpp
    tinygettext/src/unix_file_system.cpp
    tinygettext/include/tinygettext/dictionary.hpp
    tinygettext/include/tinygettext/dictionary_manager.hpp
    tinygettext/include/tinygettext/dirent.h
    tinygettext/include/tinygettext/file_system.hpp
    tinygettext/include/tinygettext/iconv.hpp
    tinygettext/include/tinygettext/language.hpp
    tinygettext/include/tinygettext/log.hpp
    tinygettext/include/tinygettext/log_stream.hpp
    tinygettext/include/tinygettext/plural_forms.hpp
    tinygettext/include/tinygettext/po_parser.hpp
    tinygettext/include/tinygettext/tinygettext.hpp
    tinygettext/include/tinygettext/unix_file_system.hpp
  USES_SDL2
  USES_STD_FS
)
wl_include_directories(tinygettext ${CMAKE_CURRENT_SOURCE_DIR}/tinygettext/include)

=== src/third_party/tinygettext/CMakeLists.txt ===
# tinygettext - A gettext replacement that works directly on .po files
# Copyright (C) 2006 Christoph Sommer <christoph.sommer@2006.expires.deltadevelopment.de>,
#               2020 Ingo Ruhnke <grumbel@gmail.com>
#
# This software is provided 'as-is', without any express or implied
# warranty. In no event will the authors be held liable for any damages
# arising from the use of this software.
#
# Permission is granted to anyone to use this software for any purpose,
# including commercial applications, and to alter it and redistribute it
# freely, subject to the following restrictions:
#
# 1. The origin of this software must not be misrepresented; you must not
#    claim that you wrote the original software. If you use this software
#    in a product, an acknowledgement in the product documentation would be
#    appreciated but is not required.
# 2. Altered source versions must be plainly marked as such, and must not be
#    misrepresented as being the original software.
# 3. This notice may not be removed or altered from any source distribution.

project(tinygettext VERSION "0.2.0")

file(GLOB TINYGETTEXT_SOURCES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} src/*.cpp)
file(GLOB TINYGETTEXT_HEADERS RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} include/tinygettext/*.hpp)

add_library(tinygettext STATIC ${TINYGETTEXT_SOURCES})
set_target_properties(tinygettext PROPERTIES
  CXX_STANDARD 17
  CXX_STANDARD_REQUIRED ON
  CXX_EXTENSIONS OFF
  PUBLIC_HEADER "${TINYGETTEXT_HEADERS}")
target_include_directories(tinygettext PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>)
target_compile_definitions(tinygettext PRIVATE VERSION=${TINYGETTEXT_VERSION})

if(WIN32)
  set(TGT_SDL_DEFAULT ON)
else()
  set(TGT_SDL_DEFAULT OFF)
endif()
option(TINYGETTEXT_WITH_SDL "Use SDL's iconv implementation with tinygettext. Ideal for Windows" ${TGT_SDL_DEFAULT})

if(TINYGETTEXT_WITH_SDL)
  # If your CMake configuration is failing here, that's because
  # the variables SDL2_LIBRARY and SDL2_INCLUDE_DIRS must be defined.
  # You can use find_package or pkgconfig before adding this submodule
  # to fix this issue.
  target_compile_definitions(tinygettext PUBLIC TINYGETTEXT_WITH_SDL)
  target_link_libraries(tinygettext PUBLIC ${SDL2_LIBRARY})
  target_include_directories(tinygettext PUBLIC ${SDL2_INCLUDE_DIRS})
else()
  find_package(Iconv REQUIRED)
  target_link_libraries(tinygettext PUBLIC Iconv::Iconv)
endif()

if(WIN32)
  target_compile_definitions(tinygettext PRIVATE _CRT_SECURE_NO_WARNINGS)
endif()

configure_file(tinygettext.pc.in tinygettext.pc @ONLY)

install(TARGETS tinygettext
  EXPORT tinygettext-targets
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME})
install(FILES ${tinygettext_BINARY_DIR}/tinygettext.pc
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

# EOF #

=== debian/changelog ===
widelands (2:1.3.1-2) unstable; urgency=medium

  * Merge the team upload 2:1.3-2. Sorry for not including it in the
    first place in 2:1.3.1-1.

 -- Martin Quinson <mquinson@debian.org>  Fri, 27 Feb 2026 15:42:12 +0100

widelands (2:1.3.1-1) unstable; urgency=medium

  * New upstream dot release, fixing a severe multiplayer desync.

 -- Martin Quinson <mquinson@debian.org>  Mon, 23 Feb 2026 21:19:43 +0100
